#include <DS3231.h>
#include <Wire.h>
#include <Thread.h>

//процесс опроса кнопки
Thread btnThread = Thread(); 
int btnInterval     = 100; 

//процесс поддеражния режима
Thread workThread = Thread(); 
int workInterval     = 1; 

//процесс мигания
Thread wblinkThread = Thread(); 
int wblinkInterval     = 500; 
 
// выводы для дешифратора
  int out1 = 7;
  int out2 = 10;
  int out4 = 12;
  int out8 = 8;
// выводы для транзисторных ключей
  int key1= 2;
  int key2 = 3;
  int key3 = 5;
  int key4 = 6;
 
  int dots = 4; // вывод мигающих точек (dots)
  int bled = A1; //внешний синий светодиод
  int lightSensor = A3; //датчик света
  int lightlimit = 150; //уровень срабатывания датчика света 0-1023

  int dynOn = 1; //время которое горят или нет лампы
  int dynOff = 1;
  
  int enable = A2; //если на выходе 1, часы включены
  //static bool enabled = false; //включен ли часы сейчас
  unsigned long harakiriTimer = 0;//обновляемыйсчетчик работы
  unsigned long harakiriEnStart = 0;//счетчик со работы
  int harakiriPause = 2000;//циклов до самоотключения
  int harakiriEnPause = 200;// задержка после включения

  int BUTTON_PIN1 = 1;// кнопка 1, она-же включение
  int BUTTON_PIN2 = 0;// кнопка 2
  int btn1LCount = 0; //счетчик циклов для долгово зажатия
  int btnLongPush = 500/btnInterval; // что считать долгим нажатием 
  bool dviceStarted = 1; 

  int buttonState1, buttonState2;

  int piezoPin = 11;
  int picCount = 0; //количество пиков для таймера смены фильтра

  unsigned long dpause = 0; //задержка для режимов
  unsigned long ddpause = 0; //значение задержки для режимов
  //unsigned long worktime = 10000; //время показывания времени
 
  int digits[4]; // массив для текущего значения времени на четыре цифры
  int lastdigits[4]; //для отслеживания изменения циферблата и включения перебора аньтиотравления
  int tdigits[4];
  int digitsEn[6]; //массив включенных знаков
  
  int mode = 0; //0 - отображение текущего времени, 3- установка времени, 1-температура, 2-таймер
  int setMode=0; //0 - установка часов, 1 - установка минут
  int currentdigit = 0; //0 - установка часов 1- установка минут
  bool blinkflag = 0; // флаг для мигания цифр при установке времени
  bool lblinkflag = 0; // прошлое состояние мигалки для счетчика пиков
  //bool timeout=false; // таймаут после нажатия кнопки (для устраниния дребезга)
  int doNothing1 = 0; //переменная для пропуска циклов 1 кнопки
  int doNothing2 = 0; //переменная для пропуска циклов 2 кнопки

  RTClib RTC;
  unsigned long lUnixtime;

  // переменные, необходимые для работы ds3231
  DS3231 Clock;
  bool h12;
  bool PM;

  
 
  //определяем глобальные переменные для различных параметров часов
  int second,minute,hour;
  
 
void setup() {
  // задаем частоту ШИМ на 9 выводе 30кГц
  TCCR1B=TCCR1B&0b11111000|0x01;
  analogWrite(9,130);
 
  // Start the I2C interface
  Wire.begin();
  
  //задаем режим работы выходов микроконтроллера
  pinMode(out1,OUTPUT);
  pinMode(out2,OUTPUT);
  pinMode(out4,OUTPUT);
  pinMode(out8,OUTPUT);
 
  pinMode(key1,OUTPUT);
  pinMode(key2,OUTPUT);
  pinMode(key3,OUTPUT);
  pinMode(key4,OUTPUT);
  pinMode(dots,OUTPUT);
  
  pinMode(bled,OUTPUT);
  pinMode(lightSensor, INPUT);
  pinMode(dots,OUTPUT);
  pinMode(piezoPin,OUTPUT);
  noTone(piezoPin);
  digitalWrite(piezoPin,HIGH);
  
  pinMode(enable,OUTPUT);
  digitalWrite(enable,HIGH);

  pinMode(BUTTON_PIN1, INPUT);
  pinMode(BUTTON_PIN2, OUTPUT);//непонятно как, но работает. 
  digitalWrite(BUTTON_PIN2,LOW);//Если не задать низкий уровень на входе 0(RX), то там будет высокий уровень, и кнопка будет вечно нажатой.
  //pinMode(BUTTON_PIN2, INPUT);
  

  btnThread.onRun(btn);
  btnThread.setInterval(btnInterval);

  workThread.onRun(work);
  workThread.setInterval(workInterval);

  wblinkThread.onRun(wblink);
  wblinkThread.setInterval(wblinkInterval);

  harakiriTimer = harakiriPause;
  harakiriEnStart = harakiriPause;
}
 
void ReadDS3231()   //функция считывает в глобальные переменные minute и hour текущие значения
{
  minute=Clock.getMinute();
  hour=Clock.getHour(h12, PM);
}
 

//опрос кнопки
void btn() {
  buttonState1 = digitalRead(BUTTON_PIN1);
  buttonState2 = digitalRead(BUTTON_PIN2);
  
  if(harakiriTimer<harakiriPause-harakiriEnPause) {dviceStarted=0;}//чтобы режимы не перещелкивались при включении
  
  if(dviceStarted==0)
    {
    if (buttonState1==HIGH) {
      if(btn1LCount<=0 && mode!=3){mode++; dpause=0; if(mode>2){mode=0;}}
      harakiriTimer=harakiriPause;
      btn1LCount++;
      }
    else if(mode!=3)
      {btn1LCount=0;}
    if(btn1LCount>=btnLongPush) {if(mode!=3){mode=3;} else {mode=0;} btn1LCount=0;}
    }
    
  //lastButtonState1=buttonState1;
  }

//процесс поддеражния режима
void work() {
  //авто отключение часов
  if(harakiriTimer<=0){digitalWrite(enable,LOW);}
  else {
    harakiriTimer--; if(harakiriTimer<=0) {harakiriTimer=0;}
    //harakiriEnStart--; if(harakiriEnStart<=0) {harakiriEnStart=0;}
    }
  
  //автоматический переход в режим часов из других режимов если долго зажато
  if(dpause>0 && mode>0){dpause--; if(dpause<=0){mode=0; dpause=0;}}
  
  if(mode==0)//отображение текущего времени
    {showTime(); }
  else if(mode==1)//отображение температуры
    {showTemperature();} 
  else if(mode==2)//секундомер
    {gasTimer();} 
  else if(mode==3)//настройка времени
    {timeSet();} 

  //антиотравление
  if(mode!=1 && mode!=2 && mode!=3)
    {
    if (lastdigits[0]!=digits[0]||lastdigits[1]!=digits[1]||lastdigits[2]!=digits[2]||lastdigits[3]!=digits[3])//lastdigits[4]
      {
      tdigits[0]=lastdigits[0];
      tdigits[1]=lastdigits[1];
      tdigits[2]=lastdigits[2];
      tdigits[3]=lastdigits[3];
      
      Safe(digits);
  
      lastdigits[0]=digits[0];
      lastdigits[1]=digits[1];
      lastdigits[2]=digits[2];
      lastdigits[3]=digits[3];
      }
    }

  if(mode!=2){lUnixtime=0;}
  
  show(digits, digitsEn); // выводим цифры на дисплей

  lightBled(); //реакция синего диода на свет 
  }

//мигание
void wblink() {
    blinkflag=!blinkflag; // инвертируем флаг мигающей цифры
    if(mode!=3){ReadDS3231();}//заодно спрашиваем время у RTS
  }


//отображение текущего времени
void showTime() {
  digits[0] = hour/10;
  digits[1] = hour%10;
  digits[2] = minute/10;
  digits[3] = minute%10;

  digitsEn[0] = 1;
  digitsEn[1] = 1;
  digitsEn[2] = 1;
  digitsEn[3] = 1;
  digitsEn[4] = blinkflag;
  digitsEn[5] = 0;
  }

//отображение температуры
void showTemperature() {
  float ftemperature=Clock.getTemperature();
  static char outstr[4];
  
  dtostrf(ftemperature,4, 2, outstr);

  digits[0] = outstr[0]-'0'; 
  digits[1] = outstr[1]-'0'; 
  digits[2] = outstr[2]-'0';
  digits[3] = outstr[3]-'0';

  digitsEn[0] = 1;
  digitsEn[1] = 1;
  digitsEn[2] = 1;
  digitsEn[3] = 1;
  digitsEn[4] = 1;
  digitsEn[5] = 0;

  ddpause=1000;
  if(dpause<=0){dpause=ddpause;}
  }


//таймер замены фильтра
void gasTimer() {
  
  //вычислям время
  DateTime now = RTC.now();
  unsigned long unixtime = now.unixtime();
  int StartUSeconds = 300;//300
  int uSeconds = StartUSeconds-(unixtime-lUnixtime);
  int sMinutes = uSeconds/60;
  int sSeconds = uSeconds-(sMinutes*60);
  
  if(lUnixtime<=0){lUnixtime=unixtime;}

  //пикания каждую минуту
  if(uSeconds==240) {picCount=1;}
  else if(uSeconds==180) {picCount=3;}
  else if(uSeconds==120) {picCount=5;}
  else if(uSeconds==60) {picCount=7;}
  else if(uSeconds==0)  {
    picCount=30;

    }


  if(picCount>0) {
    if(blinkflag!=lblinkflag)
      {
      picCount--; 
      lblinkflag=blinkflag;
      digitsEn[5] = blinkflag;
      digitsEn[0] = blinkflag;
      digitsEn[1] = blinkflag;
      digitsEn[2] = blinkflag;
      digitsEn[3] = blinkflag;
      }
    }
  else {
    digitsEn[5] = 0; 
    digitsEn[0] = 1;
    digitsEn[1] = 1;
    digitsEn[2] = 1;
    digitsEn[3] = 1;
    
    lblinkflag=blinkflag;
    harakiriTimer=harakiriPause;
    }
  
  digits[0] = sMinutes/10;
  digits[1] = sMinutes%10;
  digits[2] = sSeconds/10;
  digits[3] = sSeconds%10;


  digitsEn[4] = blinkflag;
  }


//настройка времени
void timeSet() {
  
  dpause=0;

  if(buttonState1==HIGH) {
    doNothing1++; if(doNothing1>15) {doNothing1=0;}
    if(doNothing1==0) {setMode++; if(setMode>1){setMode=0;}}
    }
  else {doNothing1=0; btn1LCount=0;}

  if(setMode==0)
    {
    digitsEn[0] = blinkflag;
    digitsEn[1] = blinkflag;
    digitsEn[2] = 1;
    digitsEn[3] = 1;
      
    if (buttonState2==HIGH) {
      digitsEn[0] = 1;
      digitsEn[1] = 1;
      
      doNothing2++; if(doNothing2>15) {doNothing2=0;}
      if(doNothing2==0) {hour++; if(hour>23){hour=0;} Clock.setHour(hour);}
      }
    }
  else if(setMode==1)
    {
    digitsEn[0] = 1;
    digitsEn[1] = 1;
    digitsEn[2] = blinkflag;
    digitsEn[3] = blinkflag;
    
    if (buttonState2==HIGH) {
      digitsEn[2] = 1;
      digitsEn[3] = 1;
      doNothing2++; if(doNothing2>15) {doNothing2=0;}
      if(doNothing2==0) {minute++; if(minute>59){minute=0;}  Clock.setMinute(minute);}
      }  
    }

  digits[0] = hour/10;
  digits[1] = hour%10;
  digits[2] = minute/10;
  digits[3] = minute%10;

  digitsEn[4] = 0;
  digitsEn[5] = 0;
  }


//реакция синего диода на свет 
void lightBled() {
  int light = analogRead(lightSensor);
  if(light>lightlimit)
    {digitalWrite(bled,HIGH);}
  else
    {digitalWrite(bled,LOW);}
  }

void loop() {
  if (btnThread.shouldRun()){btnThread.run();}
  if (workThread.shouldRun()){workThread.run();}
  if (wblinkThread.shouldRun()){wblinkThread.run();}
  }

void show(int a[], int en[])
{
  //выведем цифру a[0] на первый индикатор
  setNumber(a[0]);
  if(en[0]){digitalWrite(key1,HIGH);}
  delay(dynOn);
  //потушим первый индикатор
  digitalWrite(key1,LOW);
  delay(dynOff);
  
  //цифра a[1] на второй индикатор
  setNumber(a[1]);
  if(en[1]){digitalWrite(key2,HIGH);}
  delay(dynOn);
  //потушим второй индикатор
  digitalWrite(key2,LOW);
  delay(dynOff);
  
  //цифра a[2] на третий индикатор
  setNumber(a[2]);
  if(en[2]){digitalWrite(key3,HIGH);}
  delay(dynOn);
  //потушим третий индикатор
  digitalWrite(key3,LOW);
  delay(dynOff);
  
  //выведем цифру a[3] на четвертый индикатор
  setNumber(a[3]);
  if(en[3]){digitalWrite(key4,HIGH);}
  delay(dynOn);
  //потушим четвертый индикатор
  digitalWrite(key4,LOW);
  delay(dynOff);

  if(en[4]) // светодиоды не горят
    {digitalWrite(dots,HIGH); delay(dynOn);} // зажечь светодиоды
  if(!en[4]) // светодиоды горят
    {digitalWrite(dots,LOW); delay(dynOff);} // потушить светодиоды 

  if(!en[5]) // не пищит
    {noTone(piezoPin);} //noTone(piezoPin);digitalWrite(piezoPin,HIGH);
  if(en[5]) // пищит
    {tone(piezoPin, 1000);} //analogWrite(piezoPin, 50);tone(piezoPin, 2000);digitalWrite(piezoPin,LOW);
}

// передача цифры на дешифратор
void setNumber(int num) 
{
  switch (num)
  {
    case 0:
    digitalWrite (out1,LOW);
    digitalWrite (out2,LOW);
    digitalWrite (out4,LOW);
    digitalWrite (out8,LOW);
    break;
    case 1:
    digitalWrite (out1,HIGH);
    digitalWrite (out2,LOW);
    digitalWrite (out4,LOW);
    digitalWrite (out8,LOW);
    break;
    case 2:
    digitalWrite (out1,LOW);
    digitalWrite (out2,HIGH);
    digitalWrite (out4,LOW);
    digitalWrite (out8,LOW);
    break;
    case 3:
    digitalWrite (out1,HIGH);
    digitalWrite (out2,HIGH);
    digitalWrite (out4,LOW);
    digitalWrite (out8,LOW);
    break;
    case 4:
    digitalWrite (out1,LOW);
    digitalWrite (out2,LOW);
    digitalWrite (out4,HIGH);
    digitalWrite (out8,LOW);
    break;
    case 5:
    digitalWrite (out1,HIGH);
    digitalWrite (out2,LOW);
    digitalWrite (out4,HIGH);
    digitalWrite (out8,LOW);
    break;
    case 6:
    digitalWrite (out1,LOW);
    digitalWrite (out2,HIGH);
    digitalWrite (out4,HIGH);
    digitalWrite (out8,LOW);
    break;
    case 7:
    digitalWrite (out1,HIGH);
    digitalWrite (out2,HIGH);
    digitalWrite (out4,HIGH);
    digitalWrite (out8,LOW);
    break;
    case 8:
    digitalWrite (out1,LOW);
    digitalWrite (out2,LOW);
    digitalWrite (out4,LOW);
    digitalWrite (out8,HIGH);
    break;
    case 9:
    digitalWrite (out1,HIGH);
    digitalWrite (out2,LOW);
    digitalWrite (out4,LOW);
    digitalWrite (out8,HIGH);
    break;
  }
}

void Safe(int n[])
{
  int h1 = n[0];
  int h2 = n[1];
  int m1 = n[2];
  int m2 = n[3];

  int en[6]; en[0]=1; en[1]=1; en[2]=1; en[3]=1; en[4]=0; en[5]=0; 

  n[0]++;
  while(n[0]!=h1)
  {
    
    for (int x=0;x<2;x++)
    {
      show(n, en);
    }
    n[0]++;
    if (n[0]>9) n[0]=0;
  }
  
  n[1]++;
  while(n[1]!=h2)
  {
    
    for (int x=0;x<2;x++)
    {
      show(n, en);
    }
    n[1]++;
    if (n[1]>9) n[1]=0;
  }
  
  n[2]++;
  while(n[2]!=m1)
  {
    
    for (int x=0;x<2;x++)
    {
      show(n, en);
    }
    n[2]++;
    if (n[2]>9) n[2]=0;
  }
  
  n[3]++;
  while(n[3]!=m2)
  {
    
    for (int x=0;x<2;x++)
    {
      show(n, en);
    }
    n[3]++;
    if (n[3]>9) n[3]=0;
  }
  

}
